#!/usr/bin/env ruby
# index.rb $Revision: 1.7 $
$KCODE= 'e'
BEGIN { $defout.binmode }

begin
	if FileTest::symlink?( __FILE__ ) then
		org_path = File::dirname( File::readlink( __FILE__ ) )
	else
		org_path = File::dirname( __FILE__ )
	end
	$:.unshift( org_path.untaint )
	require 'mobo'

	@cgi = CGI::new
	conf = MoBo::Config::new
	mobo = nil

	begin
		if @cgi.valid?( 'plugin' ) then
			mobo = MoBo::MoBoPlugin::new( @cgi, "plugin.rhtml", conf )
		elsif @cgi.valid?( 'date' ) then
			date = @cgi.params['date'][0]
			if /^\d{4}$/ =~ date then
				mobo = MoBo::MoBoReport::new( @cgi, "report.rhtml", conf )
			elsif /^\d{6}$/ =~ date then
				mobo = MoBo::MoBoMonth::new( @cgi, "month.rhtml", conf )
			end
		else
			mobo = MoBo::MoBoMonth::new( @cgi, "month.rhtml", conf )
		end
	rescue MoBo::PermissionError
		raise
	rescue MoBo::MoBoError
	end
	mobo = MoBo::MoBoMonth::new( @cgi, "month.rhtml", conf ) if not mobo

	begin
		head = {
			'type' => 'text/html',
			'Vary' => 'User-Agent'
		}
		body = ''
		if @cgi.mobile_agent? then
			body = conf.to_mobile( mobo.eval_rhtml( 'i.' ) )
			head['charset'] = conf.mobile_encoding
			head['Content-Length'] = body.size.to_s
		else
			body = mobo.eval_rhtml
			head['charset'] = conf.encoding
			head['Content-Length'] = body.size.to_s
			head['Pragma'] = 'no-cache'
			head['Cache-Control'] = 'no-cache'
		end

		print @cgi.header( head )
		print body if /HEAD/i !~ @cgi.request_method
	end
rescue Exception
	if @cgi then
		print @cgi.header( 'type' => 'text/plain' )
	else
		print "Content-Type: text/plain\n\n"
	end
	puts "#$! (#{$!.class})"
	puts ""
	puts $@.join( "\n" )
end
