#
# make navigation buttons
#
def navi
	result = %Q[<div class="adminmenu">\n]
	result << %Q[<span class="adminmenu"><a href="#{@conf.index_page}">ȥå</a></span>\n] unless @conf.index_page.empty?
	result << %Q[<span class="adminmenu"><a href="#{@conf.index}?date=#{@prev_month}#{account_link}">&laquo;#{navi_prev_month}</a></span>\n] if @mode == 'month'
	result << %Q[<span class="adminmenu"><a href="#{@conf.index}">#{navi_latest}</a></span>\n]
	result << %Q[<span class="adminmenu"><a href="#{@conf.index}?date=#{@next_month}#{account_link}">#{navi_next_month}&raquo;</a></span>\n] if @mode == 'month'
	result << %Q[<span class="adminmenu"><a href="#{@conf.index}?date=#{@year}#{account_link}">#{navi_total}</a></span>\n] unless @mode == 'report'
	result << %Q[<span class="adminmenu"><a href="#{@conf.index}?date=#{@year}#{@month}">#{navi_back}</a></span>\n] if @mode == 'edit'
	result << %Q[<span class="adminmenu"><a href="#{@conf.update}?edit=1&amp;date=#{@year}#{@month}">#{navi_edit}</a></span>\n] if @mode == 'month'
	result << %Q[<span class="adminmenu"><a href="#{@conf.update}?conf=default">#{navi_preference}</a></span>\n]
	menu_proc.each {|i| result << %Q[<span class="adminmenu">#{i}</span>\n]}
	result << %Q[</div>]
end

def mobile_navi
	calc_links
	result = []
	result << %Q[<a href="#{@conf.index}?date=#{@prev_month}" accesskey="1">[1]#{mobile_navi_prev_month}</a>] if @mode == 'month'
	result << %Q[<a href="#{@conf.index}" accesskey="2">[2]#{mobile_navi_latest}</a>]
	result << %Q[<a href="#{@conf.index}?date=#{@next_month}" accesskey="3">[3]#{mobile_navi_next_month}</a>] if @mode == 'month'
	result << %Q[<a href="#{@conf.update}?conf=default" accesskey="0">[0]#{mobile_navi_preference}</a>]
	result.join('|')
end

#
# make calendar
#
def calendar
	result = %Q[<div class="calendar">\n]
	@years.keys.sort.each do |year|
		result << %Q[<div class="year"><a href="#{@conf.index}?date=#{year}#{account_link}">#{year}</a> |]
		"01".upto( "12" ) do |m|
			if @years[year].include?( "#{year}#{m}" ) then
				result << %Q[<a href="#{@conf.index}?date=#{year}#{m}#{account_link}">#{m}</a>|]
			else
				result << %Q[#{m}|]
			end
		end
		result << "</div>\n"
	end
	result << "</div>"
end

#
# define DOCTYPE
#
def doctype
	%Q[<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">]
end

#
# default HTML header
#
add_header_proc do
	calc_links
	<<-HEADER
	<meta http-equiv="content-type" content="text/html; charset=#{charset}">
	<meta name="generator" content="MoBo #{MOBO_VERSION}">
	#{content_script_type}
	#{index_page_tag}
	#{css_tag.chomp}
	#{title_tag.chomp}
	HEADER
end

def calc_links
	if @month == "01" then
		@prev_month = "#{ sprintf('%04d', @year.to_i-1) }12"
	else
		@prev_month = "#{@year}#{ sprintf('%02d', @month.to_i-1) }"
	end

	if @month == "12" then
		@next_month = "#{@year.succ}01"
	else
		@next_month = "#{@year}#{@month.succ}"
	end
end

def charset
	if @conf.mobile_agent? then
		@conf.mobile_encoding
	else
		@conf.encoding
	end
end

def content_script_type
	%Q[<meta http-equiv="content-script-type" content="text/javascript; charset=#{charset}">]
end

def index_page_tag
	result = ''
	if @conf.index_page and @conf.index_page.size > 0 then
		result << %Q[<link rel="start" title="#{navi_index}" href="#{@conf.index_page}">\n\t]
	end
	result << %Q[<link rel="last" title="#{navi_latest}" href="#{@conf.index}">\n\t]
	result.chop.chop
end

def theme_url; 'theme'; end

def css_tag
	if @conf.theme and @conf.theme.length > 0 then
		css = "#{theme_url}/#{@conf.theme}/#{@conf.theme}.css"
		title = css
	else
		css = @conf.css
	end
	title = CGI::escapeHTML( File::basename( css, '.css' ) )
	<<-CSS
<meta http-equiv="content-style-type" content="text/css">
	<link rel="stylesheet" href="#{theme_url}/mobo_base.css" type="text/css" media="all">
	<link rel="stylesheet" href="#{css}" title="#{title}" type="text/css" media="all">
	CSS
end

def account_link
	if @account
		return '&amp;account='+CGI::escape(@account)
	else
		''
	end
end

def account_title
	if @account
		return @account + ' '
	else
		''
	end
end

add_onload_proc do
	if @mode == 'report' then
		<<-SCRIPT
		document.getElementById('expense-all').style.display = 'none';
		document.getElementById('income-all').style.display = 'none';
		SCRIPT
	end
end

#
# other resources
#

#
# preferences
#

# basic (default)
def saveconf_default
	if @mode == 'saveconf' then
		@conf.index_page = @cgi.params['index_page'][0]
		@conf.hour_offset = @cgi.params['hour_offset'][0].to_f
	end
end

# header/footer (header)
def saveconf_header
	if @mode == 'saveconf' then
		@conf.html_title = @conf.to_native( @cgi.params['html_title'][0] )
		@conf.header = @conf.to_native( @cgi.params['header'][0] ).gsub( /\r\n/, "\n" ).gsub( /\r/, '' ).sub( /\n+\z/, '' )
		@conf.footer = @conf.to_native( @cgi.params['footer'][0] ).gsub( /\r\n/, "\n" ).gsub( /\r/, '' ).sub( /\n+\z/, '' )
	end
end

# genre/account
def saveconf_genre
	if @mode == 'saveconf' then
		genre_income2 = []
		@conf.to_native( @cgi.params['genre_income'][0] ).each do |i|
			i.strip!
			genre_income2 << i if i.length > 0
		end
		@conf.genre_income = genre_income2
		genre_expense2 = []
		@conf.to_native( @cgi.params['genre_expense'][0] ).each do |i|
			i.strip!
			genre_expense2 << i if i.length > 0
		end
		@conf.genre_expense = genre_expense2
		genre_move2 = []
		@conf.to_native( @cgi.params['genre_move'][0] ).each do |i|
			i.strip!
			genre_move2 << i if i.length > 0
		end
		@conf.genre_move = genre_move2
		account_list2 = []
		@conf.to_native( @cgi.params['account_list'][0] ).each do |i|
			i.strip!
			account_list2 << i if i.length > 0
		end
		@conf.account_list = account_list2
	end
end

# themes
def saveconf_theme
	# dummy
end

if @mode =~ /^(conf|saveconf)$/ and @cgi.params['conf'][0] == 'theme' then
	if @mode == 'saveconf' then
		@conf.theme = @cgi.params['theme'][0]
		@conf.css = @cgi.params['css'][0]
	end

	@conf_theme_list = []
	Dir::glob( "#{::MoBo::PATH}/theme/*" ).sort.each do |dir|
		theme = dir.sub( %r[.*/theme/], '')
		next unless FileTest::file?( "#{dir}/#{theme}.css".untaint )
		name = theme.split( /_/ ).collect{|s| s.capitalize}.join( ' ' )
		@conf_theme_list << [theme,name]
	end
end

# account group
def saveconf_account
	if @mode == 'saveconf' then
		@conf.vaccount_name = []
		@conf.vaccount_list = []
		0.upto(9) do |i|
			next if @cgi.params["vaccount_name#{i}"] == ''
			next if @conf.account_list.include?( @cgi.params["vaccount_name#{i}"] )
			next if @cgi.params["vaccount_list#{i}"].size == 0
			@conf.vaccount_name << @cgi.params["vaccount_name#{i}"][0]
			@conf.vaccount_list << @cgi.params["vaccount_list#{i}"]
		end
	end
end
