#
# en/00default.rb: English resources of 00default.rb.
#

#
# header
#
def title_tag
	r = "<title>#{CGI::escapeHTML( @conf.html_title )}"
	case @mode
	when 'day', 'comment'
		r << " (#{account_title}#{@year}/#{@month}/#{@day})" if @date
	when 'month'
		r << " (#{account_title}#{@year}/#{@month})" if @date
	when 'edit'
		r << " (#{navi_edit} #{@year}/#{@month})" if @date
	when 'report'
		r << " (#{account_title}#{@year})" if @year
	when 'conf'
		r << ' (Preferences)'
	when 'saveconf'
		r << ' (Preferences Changed)'
	end
	r << '</title>'
end

#
# labels (normal)
#
def navi_index; 'Top'; end
def navi_latest; 'Latest'; end
def navi_edit; 'Edit'; end
def navi_total; 'Reckoning'; end
def navi_back; 'Back'; end
def navi_preference; 'Preference'; end
def navi_prev_month; 'Prev'; end
def navi_next_month; 'Next'; end

#
# labels (for mobile)
#
def mobile_navi_latest; 'Latest'; end
def mobile_navi_preference; 'Prefs'; end
def mobile_navi_prev_month; 'Prev'; end
def mobile_navi_next_month; 'Next'; end

#
# preferences (resources)
#
add_conf_proc( 'default', 'Basic' ) do
	saveconf_default
	<<-HTML
	<h3 class="subtitle">URL of index page</h3>
	#{"<p>The URL of index of your website if you have.</p>" unless @conf.mobile_agent?}
	<p><input name="index_page" value="#{@conf.index_page}" size="50"></p>
	<h3 class="subtitle">Time difference adjustment</h3>
	#{"<p>When updating your account book, you can adjust date which is automatically inserted into the form. The unit is hour. For example, if you want to handle the time until 2 a.m. as the previous day, you set this to -2. MoBo inserts the date which is older by 2 hours than the actual time. </p>" unless @conf.mobile_agent?}
	<p><input name="hour_offset" value="#{@conf.hour_offset}" size="5"></p>
	HTML
end

add_conf_proc( 'header', 'Header/Footer' ) do
	saveconf_header

	<<-HTML
	<h3 class="subtitle">Title</h3>
	#{"<p>The title of your account book. This value is used in HTML &lt;title&gt; element and in mobile mode. Do not use HTML tags.</p>" unless @conf.mobile_agent?}
	<p><input name="html_title" value="#{ CGI::escapeHTML @conf.html_title }" size="50"></p>
	<h3 class="subtitle">Header</h3>
	#{"<p>This text is inserted into top of each pages. You can use HTML tags. Do not remove \"&lt;%=navi%&gt;\", because it mean Navigation bar inclued \"Update\" button. And \"&lt;%=calendar%&gt;\" mean calendar. So you can specify other plugins also.</p>" unless @conf.mobile_agent?}
	<p><textarea name="header" cols="70" rows="10">#{ CGI::escapeHTML @conf.header }</textarea></p>
	<h3 class="subtitle">Footer</h3>
	#{"<p>This text is inserted into bottom of each pages. You can specify as same as Header.</p>" unless @conf.mobile_agent?}
	<p><textarea name="footer" cols="70" rows="10">#{ CGI::escapeHTML @conf.footer }</textarea></p>
	HTML
end

add_conf_proc( 'genre', 'Genres/Accounts' ) do
	saveconf_genre

	<<-HTML
	#{"<p>Once you establish genres and accounts, please do not MODIFY or DELETE them (you can ADD genres and accounts later).</p>" unless @conf.mobile_agent?}
	<h3 class="subtitle">Genre (income)</h3>
	#{"<p>Specify genres of income (a genre into a line).</p>" unless @conf.mobile_agent?}
	<p><textarea name="genre_income" cols="40" rows="10">#{ @conf.genre_income.join( "\n" ) }</textarea></p>
	<h3 class="subtitle">Genre (expense)</h3>
	#{"<p>Specify genres of expense (a genre into a line).</p>" unless @conf.mobile_agent?}
	<p><textarea name="genre_expense" cols="40" rows="10">#{ @conf.genre_expense.join( "\n" ) }</textarea></p>
	<h3 class="subtitle">Genre (move)</h3>
	#{"<p>Specify genres of move (a genre into a line).</p>" unless @conf.mobile_agent?}
	<p><textarea name="genre_move" cols="40" rows="10">#{ @conf.genre_move.join( "\n" ) }</textarea></p>
	<h3 class="subtitle">Account</h3>
	#{"<p>Specify your accounts (an account into a line).</p>" unless @conf.mobile_agent?}
	<p><textarea name="account_list" cols="40" rows="10">#{ @conf.account_list.join( "\n" ) }</textarea></p>
	HTML
end

add_conf_proc( 'theme', 'Themes' ) do
	saveconf_theme

	r = <<-HTML
	<h3 class="subtitle">Theme</h3>
	#{"<p>Specify the design of your diary using Theme or CSS. When you select \"CSS specify\", input URL of CSS into the field right side.</p>" unless @conf.mobile_agent?}
	<p>
	<select name="theme">
		<option value="">CSS Specify-&gt;</option>
	HTML
	@conf_theme_list.each do |theme|
		r << %Q|<option value="#{theme[0]}"#{if theme[0] == @conf.theme then " selected" end}>#{theme[1]}</option>|
	end
	r << <<-HTML
	</select>
	<input name="css" size="50" value="#{ @conf.css }">
	</p>
	#{"<p>You can get many themes from <a href=\"http://www.tdiary.org/20021001.html\">Theme Gallery</a>(Japanese).</p>" unless @conf.mobile_agent?}
	HTML
end

add_conf_proc( 'account', 'Virtual Accounts' ) do
	saveconf_account
	r = <<-HTML
	<h3 class="subtitle">Virtual Accounts</h3>
	#{"<p>You can specify your virtual accounts that combines some accounts. The name of virtual account should differ from a name of each account. If you want to remove a virtual account, let its name empty.</p>" unless @conf.mobile_agent?}
	HTML
	0.upto( 9 ) do |i|
		r << <<-HTML
	<p>Name of virtual account No. #{i+1} <input name="vaccount_name#{i}" value="#{@conf.vaccount_name[i]}" size="40">
	<select name="vaccount_list#{i}" multiple>
		HTML
		@conf.account_list.each do |account|
			r << %Q|<option value="#{account}"|
			if @conf.vaccount_list[i] && @conf.vaccount_list[i].include?( account ) then
				r << %Q| selected|
			end
			r << %Q|>#{account}</option>|
		end
		r << <<-HTML
		</select></p>
		HTML
	end
	r
end
