#
# ja/00default.rb: Japanese resources of 00default.rb.
#

#
# header
#
def title_tag
	r = "<title>#{CGI::escapeHTML( @conf.html_title )}"
	case @mode
	when 'day', 'comment'
		r << " (#{account_title}#{@year}/#{@month}/#{@day})" if @date
	when 'month'
		r << " (#{account_title}#{@year}/#{@month})" if @date
	when 'edit'
		r << " (#{navi_edit} #{@year}/#{@month})" if @date
	when 'report'
		r << " (#{account_title}#{@year})" if @year
	when 'conf'
		r << ' ()'
	when 'saveconf'
		r << ' (괰λ)'
	end
	r << '</title>'
end

#
# labels (normal)
#
def navi_index; 'ȥå'; end
def navi_latest; 'ǿ'; end
def navi_edit; 'Խ'; end
def navi_total; ''; end
def navi_back; ''; end
def navi_preference; ''; end
def navi_prev_month; ''; end
def navi_next_month; ''; end

#
# labels (for mobile)
#
def mobile_navi_latest; 'ǿ'; end
def mobile_navi_preference; ''; end
def mobile_navi_prev_month; ''; end
def mobile_navi_next_month; ''; end

#
# preferences (resources)
#
add_conf_proc( 'default', '' ) do
	saveconf_default
	<<-HTML
	<h3 class="subtitle">ȥåץڡURL</h3>
	#{"<p>ȷ̤ΥƥĤлꤷޤ¸ߤʤϲϤʤƤޤޤ</p>" unless @conf.mobile_agent?}
	<p><input name="index_page" value="#{@conf.index_page}" size="50"></p>
	<h3 class="subtitle">Ĵ</h3>
	#{"<p>եդñ̤ĴǤޤ㤨и2ޤǤȤưˤϡ-2פΤ褦˻ꤹ뤳Ȥǡ2ʬ줿դ褦ˤʤޤޤդWebоλˤʤäƤΤǡΥФǱĤƤλĴˤѤǤޤ</p>" unless @conf.mobile_agent?}
	<p><input name="hour_offset" value="#{@conf.hour_offset}" size="5"></p>
	HTML
end

add_conf_proc( 'header', 'إåեå' ) do
	saveconf_header

	<<-HTML
	<h3 class="subtitle">ȥ</h3>
	#{"<p>HTML&lt;title&gt;椪ӡХüλȻ˻Ȥ륿ȥǤHTMLϻȤޤ</p>" unless @conf.mobile_agent?}
	<p><input name="html_title" value="#{ CGI::escapeHTML @conf.html_title }" size="50"></p>
	<h3 class="subtitle">إå</h3>
	#{"<p>ȷƬʸϤꤷޤHTMLȤޤ&lt;%=navi%&gt;פǡʥӥܥǤޤ(줬ʤȹǤʤʤΤǺʤ褦ˤƤ)ޤ&lt;%=calendar%&gt;פǥǤޤ¾Ƽץ饰򵭽ҤǤޤ</p>" unless @conf.mobile_agent?}
	<p><textarea name="header" cols="70" rows="10">#{ CGI::escapeHTML @conf.header }</textarea></p>
	<h3 class="subtitle">եå</h3>
	#{"<p>ȷκǸʸϤꤷޤإåƱͤ˻Ǥޤ</p>" unless @conf.mobile_agent?}
	<p><textarea name="footer" cols="70" rows="10">#{ CGI::escapeHTML @conf.footer }</textarea></p>
	HTML
end

add_conf_proc( 'genre', '롦' ) do
	saveconf_genre

	<<-HTML
	#{"<p>̾̾ꤷ顢ɲäꤢޤ󤬡̾ѹϤʤǤ</p>" unless @conf.mobile_agent?}
	<h3 class="subtitle"> ()</h3>
	#{"<p>Υꤷޤ1 ԤˤĤ 1 ϤƤ</p>" unless @conf.mobile_agent?}
	<p><textarea name="genre_income" cols="40" rows="10">#{ @conf.genre_income.join( "\n" ) }</textarea></p>
	<h3 class="subtitle"> (ٽ)</h3>
	#{"<p>ٽФΥꤷޤ1 ԤˤĤ 1 ϤƤ</p>" unless @conf.mobile_agent?}
	<p><textarea name="genre_expense" cols="40" rows="10">#{ @conf.genre_expense.join( "\n" ) }</textarea></p>
	<h3 class="subtitle"> (ư)</h3>
	#{"<p>ưΥꤷޤ1 ԤˤĤ 1 ϤƤ</p>" unless @conf.mobile_agent?}
	<p><textarea name="genre_move" cols="40" rows="10">#{ @conf.genre_move.join( "\n" ) }</textarea></p>
	<h3 class="subtitle"></h3>
	#{"<p>¤ΥꥹȤꤷޤ1 ԤˤĤ 1 ¤ϤƤ</p>" unless @conf.mobile_agent?}
	<p><textarea name="account_list" cols="40" rows="10">#{ @conf.account_list.join( "\n" ) }</textarea></p>
	HTML
end

add_conf_proc( 'theme', 'ơ' ) do
	saveconf_theme

	r = <<-HTML
	<h3 class="subtitle">ơޤλ</h3>
	#{"<p>ȷΥǥơޡ⤷CSSľϤǻꤷޤɥåץ˥塼CSSꢪפ򤷤ˤϡCSSURLϤƤ</p>" unless @conf.mobile_agent?}
	<p>
	<select name="theme">
		<option value="">CSSꢪ</option>
	HTML
	@conf_theme_list.each do |theme|
		r << %Q|<option value="#{theme[0]}"#{if theme[0] == @conf.theme then " selected" end}>#{theme[1]}</option>|
	end
	r << <<-HTML
	</select>
	<input name="css" size="50" value="#{ @conf.css }">
	</p>
	#{"<p>ˤʤơޤ<a href=\"http://www.tdiary.org/20021001.html\">ơޡ꡼</a>Ǥޤ</p>" unless @conf.mobile_agent?}
	HTML
end

add_conf_proc( 'account', '۸' ) do
	saveconf_account
	r = <<-HTML
	<h3 class="subtitle">۸¤λ</h3>
	#{"<p>ʣθ¤ޤȤƷ׻Ǥֲ۸¡פǤޤ ( 10 )۸¤ѤʤϲϤʤƤޤޤ󡣲۸¤̾Τϡ̤θ¤̾ΤƱˤʤʤ褦ˤƤޤ۸¤äϡ벾۸¤̾ˤƤ</p>" unless @conf.mobile_agent?}
	HTML
	0.upto( 9 ) do |i|
		r << <<-HTML
	<p>۸ #{i+1} ̾ <input name="vaccount_name#{i}" value="#{@conf.vaccount_name[i]}" size="40">
	<select name="vaccount_list#{i}" multiple>
		HTML
		@conf.account_list.each do |account|
			r << %Q|<option value="#{account}"|
			if @conf.vaccount_list[i] && @conf.vaccount_list[i].include?( account ) then
				r << %Q| selected|
			end
			r << %Q|>#{account}</option>|
		end
		r << <<-HTML
		</select></p>
		HTML
	end
	r
end
