#!/usr/bin/env ruby
# update.rb $Revision: 1.6 $
BEGIN { $defout.binmode }

begin
	if FileTest::symlink?( __FILE__ ) then
		org_path = File::dirname( File::readlink( __FILE__ ) )
	else
		org_path = File::dirname( __FILE__ )
	end
	$:.unshift( org_path.untaint )
	require 'mobo'

	@cgi = CGI::new
	conf = MoBo::Config::new
	mobo = nil

	begin
		if @cgi.valid?( 'add' ) then
			mobo = MoBo::MoBoAdd::new( @cgi, "month.rhtml", conf )
		elsif @cgi.valid?( 'edit' ) then
			mobo = MoBo::MoBoEdit::new( @cgi, "edit.rhtml", conf )
		elsif @cgi.valid?( 'savemonth' ) then
			mobo = MoBo::MoBoSaveMonth::new( @cgi, "month.rhtml", conf )
		elsif @cgi.valid?( 'saveconf' ) then
			mobo = MoBo::MoBoSaveConf::new( @cgi, "conf.rhtml", conf )
		elsif @cgi.valid?( 'conf' ) then
			mobo = MoBo::MoBoConf::new( @cgi, "conf.rhtml", conf )
		else
			mobo = MoBo::MoBoMonth::new( @cgi, "month.rhtml", conf )
		end
	rescue MoBo::PermissionError
		raise
	rescue MoBo::MoBoError
	end

	begin
		head = body = ''
		if @cgi.mobile_agent? then
			body = conf.to_mobile( mobo.eval_rhtml( 'i.' ) )
			head = @cgi.header(
				'status' => '200 OK',
				'type' => 'text/html',
				'charset' => conf.mobile_encoding,
				'Content-Length' => body.size.to_s,
				'Vary' => 'User-Agent'
			)
		else
			body = mobo.eval_rhtml
			head = @cgi.header(
				'status' => '200 OK',
				'type' => 'text/html',
				'charset' => conf.encoding,
				'Content-Length' => body.size.to_s,
				'Vary' => 'User-Agent'
			)
		end
		print head
		print body if /HEAD/i !~ @cgi.request_method
	rescue MoBo::ForceRedirect
		head = {
                        #'Location' => $!.path
                        'type' => 'text/html',
                }
                print @cgi.header( head )
                print %Q[
			<html>
			<head>
			<meta http-equiv="refresh" content="1;url=#{$!.path}">
			<title>moving...</title>
			</head>
			<body>Wait or <a href="#{$!.path}">Click here!</a></body>
			</html>]
	end
rescue Exception
	if @cgi then
		print @cgi.header( 'type' => 'text/plain' )
	else
		print "Content-Type: text/plain\n\n"
	end
	puts "#$! (#{$!.class})"
	puts ""
	puts $@.join( "\n" )
end
